/*! phoscon-app 2020-11-15 */

import{injectSwitchWizzardSvg}from"./devices/load-svg.js";import{initMachine}from"./devices/machine.js";import{createMachineContent}from"./devices/make-machine.js";import{getPageContent,translatePage}from"./devices/load-page.js";import{getScanStates}from"./devices/scan-states.js";import{START_SCAN,STOP_SCAN,DEVICE_ADDED,DEVICE_UPDATED,DEVICE_NO_UPDATED,NO_DEVICE_ADDED}from"./devices/scan-states.js";import{addClassToAll,removeClassToAll,callFunc,searchInput,slideBlindDown,slideBlindUp}from"./devices/generic-helper-functions.js";import{actions as pageActions}from"./devices/machine-actions.js";import*as c from"./devices/constants.js";import*as s from"./devices/scan-states.js";import*as scanActions from"./devices/scan-actions.js";import*as scanFunctions from"./devices/scan-functions.js";import{initDevicesBlindsView}from"./devices-blinds/devices-blinds-view.js";import{initPages}from"./devices-blinds/map.js";import{initOverview}from"./devices-blinds/overview-view.js";import{initDetailsView}from"./devices-blinds/details-view.js";const{Machine:Machine,actions:actions,State:State}=XState,{interpret:interpret}=XStateInterpreter,{send:send,sendParent:sendParent,log:log,raise:raise,assign:assign}=actions;async function initViewAndLogic(){screenMin(SCREEN_MIN_WIDTH_TABLET_PORTRAIT)&&openNav();var overviewInitial=0!==app.blinds.models.length?"table":"empty";const pageParams={constants:c,scanStates:s},generalViews=initOverview(injectSwitchWizzardSvg,pageParams,searchInput),detailsView=initDetailsView(injectSwitchWizzardSvg,pageParams);generalViews.detailsView=detailsView;const pages=initPages(pageParams),view=await initDevicesBlindsView(addClassToAll,removeClassToAll,injectSwitchWizzardSvg),states=await createMachineContent(pages,c),scanStates=await getScanStates(scanActions),functions=await getMachineFunctions(scanFunctions,getPageContent,translatePage),actions=await getPageActions(pageActions);let context={overviewInitial:overviewInitial,...functions,callFunc:callFunc,view:view,generalViews:generalViews,constants:{...c,START_SCAN:START_SCAN,STOP_SCAN:STOP_SCAN,DEVICE_ADDED:DEVICE_ADDED,DEVICE_UPDATED:DEVICE_UPDATED,DEVICE_NO_UPDATED:DEVICE_NO_UPDATED,NO_DEVICE_ADDED:NO_DEVICE_ADDED},pageParams:pageParams,noteSw:{}},pagesStates={id:"pages",initial:"page-init",states:states};const machine=await initMachine(pagesStates,scanStates,actions,Machine,interpret,context);app.machine=machine;var service=machine.context.service;view.service=service,generalViews.overview.service=service,generalViews.tableView.views.forEach(view=>{view.service=service},this),app.navItem=document.querySelector("#dBlind").parentElement,app.navItem.addEventListener("click",function(){app.router.navigate("table",{trigger:!0})}),app.headLeftBtn=document.querySelector(".header #menu-btn"),app.headLeftSvg=app.headLeftBtn.querySelector("use"),app.headLeftLabel=app.headLeftBtn.querySelector("span");var Router=Backbone.Router.extend({routes:{"table/wizard/:page":"showSwitchWizardTable","blind/:id/wizard/:page":"showSwitchWizardDetails","blind/:id":"showSwitchDetails",table:"showSwitchTable"},showSwitchDetails:function(id){app.navItem.classList.add("sub-item");let sn=app.blinds.get(id);sn&&service.send({type:"DETAILS",model:sn}),(screenMax(SCREEN_MAX_WIDTH_PHONE_PORTRAIT)||screen.height<420)&&(app.headLeftSvg.setAttribute("xlink:href","#back-icon-sm"),app.headLeftLabel.textContent=translate("link_blinds"))},showSwitchTable:function(url){app.session.blid=void 0,app.headLeftSvg.setAttribute("xlink:href","#icon-hamburger-sm"),app.headLeftLabel.textContent="",app.navItem.classList.remove("sub-item"),app.blinds.length>0?service.send("TABLE"):service.send("EMPTY")},showSwitchWizardTable:function(page){console.log("showSwitchWizard Table: "+page),service.send(page)},showSwitchWizardDetails:function(id,page){this.showSwitchDetails(id),console.log("showSwitchWizard Details: "+page),service.send(page)}});app.router=new Router,Backbone.history.start();let backboneHistoryFragment=Backbone.history.getFragment();-1!==backboneHistoryFragment.indexOf("wizard")&&($("#switchWizardModal").modal("show"),-1!==backboneHistoryFragment.indexOf("blind")?app.machine.context.nodeHistoryFragment="blind/"+app.session.blid:app.machine.context.nodeHistoryFragment="table"),app.headLeftBtn.onclick=void 0,app.headLeftBtn.addEventListener("click",function(){(screenMax(SCREEN_MAX_WIDTH_PHONE_PORTRAIT)||screen.height<420)&&document.location.hash.indexOf("blind/")>0?app.router.navigate("table",{trigger:!0}):openNav()}),app.api.on("blind-added",function(bl){machine.context.noteSw.id=bl.id,app.session.blid=bl.id,machine.context.service.send({type:DEVICE_ADDED,device:bl})},this),app.api.on("blind-changed",function(bl){machine.context.noteSw.id=bl.id,app.session.blid=bl.id,service.send({type:DEVICE_UPDATED,device:bl})},this),document.querySelectorAll("[data-modal]").forEach(elem=>{elem.addEventListener("click",function(e){let el=e.currentTarget;if(!el)return;let ev=el.getAttribute("data-btn-ev");service.send(ev)})}),loadLanguage(),$(document).on("show.bs.modal","#deleteBlindModal",function(){var bl=app.blinds.get(app.session.blid),name=bl.get("name");this.querySelector(".modal-body span b").innerText=name,this.querySelector(".modal-footer .btn-primary").addEventListener("click",function(){deleteBlind(bl,service)})}),document.querySelectorAll(".dev-scroll-cont").forEach(el=>{el.onscroll=function(){setShadowClass(this)}})}function getMachineFunctions(s,getPageContent,translatePage){return{enableSensorSearch:s.enableSensorSearch,disableSensorSearch:s.disableSensorSearch,blinkAllLights:s.blinkAllLights,renameSwitch:s.renameSwitch,getPageContent:getPageContent,translatePage:translatePage,routeToDetails:routeToDetails,setShadowClass:setShadowClass,slideBlindDown:slideBlindDown,slideBlindUp:slideBlindUp,initPages:initPages}}function getPageActions(actions){return{...actions,[c.CALL_FUNC]:callFunc}}function deleteBlind(bl,service){bl&&(app.lights.get(bl.id).destroy(),app.router.navigate("table",{trigger:!0}))}function routeToDetails(ctx,event){ctx.noteSw&&ctx.noteSw.id&&(app.router.navigate("switch/"+ctx.noteSw.id,{trigger:!0}),ctx.noteSw.id=void 0)}function setShadowClass(el){el.classList[el.scrollTop>10?"add":"remove"]("shadow-top"),el.classList[el.scrollHeight-el.clientHeight-el.scrollTop>10?"add":"remove"]("shadow-bottom")}function locationHashChanged(e){let oldHash=e.oldURL.split("#")[1],newHash=e.newURL.split("#")[1];oldHash&&newHash&&-1!==oldHash.indexOf("scan")&&-1==newHash.indexOf("scan")&&scanFunctions.disableSensorSearch()}initApp(),restGetResource(app.config).then(()=>restGetResource(app.lights)).then(()=>restGetResource(app.groups)).then(res=>{setTimeout(()=>app.poll.pollRepeated(app.config),5e3),setTimeout(()=>app.poll.pollRepeated(app.lights),5e3),app.sensorScan.fetch(),initViewAndLogic()}),window.onhashchange=locationHashChanged;