/*! phoscon-app 2020-11-15 */

export function initOverview(injectSwitchWizzardSvg,pageParams,searchInput){let tableView,svgPathsSensors=pageParams.constants.svgPathsSensors;const OverviewView=Backbone.View.extend({el:"#overview",template:_.template(document.getElementById("switch-overview-template").innerHTML),initialize:function(){this.el.innerHTML=this.template(),tableView=new TableView,this.searchInput=this.el.querySelector("#searchSensor"),this.searchInput&&this.searchInput.setAttribute("placeholder",translate("txt_search_input_sensors"))},events:{"input #searchSensor":"changeSearchField"},changeSearchField:_.debounce(function(ev){let searchViews=tableView.views||[],searchString=ev.currentTarget.value||"";searchInput(searchViews,searchString)},500),show:function(){this.el.classList.remove("hide")},hide:function(){this.el.classList.add("hide")}}),EmptyView=Backbone.View.extend({el:".empty-div",template:_.template(document.getElementById("switch-empty-template").innerHTML),initialize:function(){this.el.innerHTML=this.template()},show:function(){this.el.classList.remove("hide")},hide:function(){this.el.classList.add("hide")}}),TableView=Backbone.View.extend({el:"#switchTable",collection:app.sensors,initialize:function(){this.views=[],this.listenTo(this.collection,"add",this.addOne),this.listenTo(this.collection,"remove",this.removeOne),this.collection.forEach(this.addOne,this)},addOne:function(model){if(4===getDeviceDevtype(model.attributes))return;if(!getDeviceInfoMap(model.attributes))return;if(-1!==model.get("type").indexOf("CLIP"))return;if("ZHAConsumption"===model.get("type")||"ZHAPower"===model.get("type"))return;if(app.testEmptyState)return void console.log("don't add device in test empty state");let alreadyExists=this.views.find(function(view){return view.model.get("mac")===model.get("mac")||"PHDL00"===view.model.get("modelid")&&"PHDL00"===model.get("modelid")});var sw=app.switches.find(x=>x.get("id")===model.get("mac"));if(model.has("modelid")&&!sw&&!alreadyExists){document.body.classList.remove("empty");var view=new TableRowView({model:model});this.$el.append(view.render().el),this.views.push(view)}},removeOne:function(model){let views=this.views.filter(v=>v.model.get("id")!==model.get("id"));this.views=views}}),TableRowView=Backbone.View.extend({tagName:"tr",template:_.template($("#switch-item-template").html()),initialize:function(){this.model.set("product",getDeviceProductName(this.model.attributes)),this.model.set("producttype",getDeviceProducttype(this.model.attributes)),this.model.on("change",this.render,this),this.model.on("destroy",this.remove,this);var html=this.template(this.model.attributes);this.$el.html(html),this.$el.attr("data-snid",this.model.id),"PHDL00"===this.model.get("modelid")&&this.el.classList.add("unclickable"),this.nameLabel=this.el.querySelector("td:nth-child(2)"),this.vendorLabel=this.el.querySelector("td:nth-child(3)"),this.productLabel=this.el.querySelector("td:nth-child(4)"),this.valueLabel=this.el.querySelector(".values");let modelid=this.model.get("modelid"),iconImg=this.el.querySelector(".item-icon"),iconPath=modelid?svgPathsSensors.icon[modelid]:null;iconPath||(iconPath=svgPathsSensors.icon["#"]),iconImg.setAttribute("src",iconPath),injectSwitchWizzardSvg([iconImg]),this.service=null,this.render()},events:{click:function(){"PHDL00"!==this.model.get("modelid")&&app.router.navigate("sensor/"+this.model.id,{trigger:!0})}},render:function(){this.model.get("config").reachable||"PHDL00"===this.model.get("modelid")?this.el.classList.remove("not-reachable"):this.el.classList.add("not-reachable");const name=this.model.get("name");this.nameLabel.textContent!==name&&(this.nameLabel.textContent=name);const product=this.model.get("product");this.productLabel.textContent!==product&&(this.productLabel.textContent=product);var vendor=this.model.get("vendor")||this.model.get("manufacturername");return vendor="PHDL00"===this.model.get("modelid")?"Phoscon":vendor,this.vendorLabel.textContent!==vendor&&(this.vendorLabel.textContent=vendor),"PHDL00"===this.model.get("modelid")?getDaylightStateValues(this.model,this.el).then(stateValues=>{this.valueLabel.innerHTML=stateValues}):getStateValues(this.model).then(stateValues=>{this.valueLabel.innerHTML=stateValues}),this}});return{overview:new OverviewView,emptyview:new EmptyView,tableView:tableView}};function getStateValues(model){return new Promise((resolve,reject)=>{var sensors=app.sensors.filter(sn=>sn.get("mac")===model.get("mac"))||[],statesToShow=["presence","lightlevel","temperature","humidity","open","pressure","vibration","water","alarm"],states={},values=[];for(var state in sensors.forEach(sn=>{states=Object.assign(states,sn.get("state")||{}),(statesToShow.filter(s=>s in model.get("config"))||[]).forEach(state=>{states=Object.assign(states,{[state]:sn.get("config")[state]})})}),states)if(-1!==statesToShow.indexOf(state)){var value=states[state];"presence"===state||"vibration"===state||"water"===state||"alarm"===state?value=getSvgStateIcon(state,model):"open"===state?value=value?translate("text_isopen"):translate("text_closed"):"temperature"===state?(value=parseInt(value/100),value+="&nbsp;°C"):"humidity"===state?(value/=100,value+="&nbsp;%"):"pressure"===state?value+="&nbsp;hPa":"lightlevel"===state&&((value=Math.pow(10,value/1e4))>=1?value-=1:value=0,value=Math.round(value),value+="&nbsp;Lux",value+=value),values.push(value)}resolve(values=values.join(",&nbsp;"))})}function getDaylightStateValues(model,el){return new Promise((resolve,reject)=>{var svgElem='<svg width="24" height="24"><use transform="scale(0.5)" xlink: href="{icon}"/></svg>';console.log("render daylight sensor:",model.id);let cfg=model.get("config")||{},state=model.get("state")||{},ico="#moon-icon",txt="",status="status"in state?state.status:0;!0!==state.daylight&&160!=status||(ico="#sun-icon"),cfg.configured?status>=140&&status<160?ico="#sunrise-icon":status>=180&&status<=210&&(ico="#sunset-icon"):(el.classList.add("not-reachable"),ico="",txt=translate("text_sensor_not_reachable")),resolve(svgElem=svgElem.replace("{icon}",ico))})}function getSvgStateIcon(state,model){var svgElem='<svg width="24" height="24" class="{class}"><use transform="scale(0.5)" xlink: href="{icon}"/></svg>',stateValue=model.get("state")[state];return"presence"===state||"vibration"===state?svgElem=svgElem.replace("{icon}","#motion-detected-icon"):"water"===state?svgElem=svgElem.replace("{icon}","#water-drop-icon"):"alarm"===state&&(svgElem=svgElem.replace("{icon}","#siren")),svgElem=!0===stateValue?svgElem.replace("{class}","detect-icon detected"):svgElem.replace("{class}","detect-icon")}