/*! phoscon-app 2020-11-15 */

import{serviceSend}from"./settings-gateway-machine.js";import{states,events}from"./settings-gateway-constants.js";import{removeClassFromAll,updateDateTime,getNetworkId}from"./settings-gateway-functions.js";export const DateHandlerView=Backbone.View.extend({template:_.template(document.getElementById("date-area-view-template").innerHTML),el:"#dateArea",initialize:function(){this.el.innerHTML=this.template(app.config),this.date=this.el.querySelector("#gatewayDate"),this.time=this.el.querySelector("#gatewayTime"),this.timezone=this.el.querySelector("#gatewayTimezone"),this.listenTo(app.config,"change:UTC",this.dateTime),this.dateTime()},events:{"click button":function(){serviceSend(states.CHANGE_TIMEZONE)}},render:function(){return this},dateTime:function(){let dt=updateDateTime();dt&&(this.date.textContent=dt.date,this.time.textContent=dt.time,app.config.has("timezone")&&(this.timezone.textContent=app.config.get("timezone")))}});export const HomebridgeHandlerView=Backbone.View.extend({template:_.template(document.getElementById("homebridge-area-view-template").innerHTML),el:"#homebridgeArea",initialize:function(){this.el.innerHTML=this.template(app.config),this.homebridgePin=this.el.querySelector("#homebridgePin"),this.homebridgeVersion=this.el.querySelector("#homebridgeVersion"),this.homebridgeUpdateVersion=this.el.querySelector("#homebridgeUpdateVersion"),this.autoUpdateBtnOn=this.el.querySelector("#autoUpdateOn"),this.autoUpdateBtnOff=this.el.querySelector("#autoUpdateOff"),this.buttonsField=this.el.querySelector("#homebridgeArea #div2"),this.listenTo(app.config,"change:homebridgepin",this.setHomebridgePin),this.listenTo(app.config,"change:homebridgeversion",this.setHomebridgeVersion),this.listenTo(app.config,"change:homebridgeupdateversion",this.setHomebridgeUpdateVersion),this.listenTo(app.config,"change:homebridge",this.showHomebridgeArea),this.listenTo(app.config,"change:homebridgeupdate",this.setHomebridgeUpdateState),this.showHomebridgeArea(),this.setHomebridgePin(),this.setHomebridgeUpdateState(),this.setHomebridgeVersion(),this.setHomebridgeUpdateVersion()},events:{"click #resetHomebridgeBtn":function(){serviceSend(states.RESET_HOMEBRIDGE)},"click #autoUpdateOn":"activateAutoUpdate","click #autoUpdateOff":"deactivateAutoUpdate"},showHomebridgeArea:function(){let homebridge=app.config.get("homebridge");if(app.config.has("homebridge")&&"not-managed"!==homebridge&&"not-available"!==homebridge)if(this.el.classList.remove("hidden"),"installing"===homebridge)this.homebridgePin.textContent=translate("txt_hb_installing"),this.buttonsField.classList.add("hidden");else if("install-error"===homebridge)this.homebridgePin.textContent=translate("txt_hb_install_error"),this.buttonsField.classList.add("hidden");else{let pin=app.config.get("homebridgepin"),version=app.config.get("homebridgeversion");if(!pin||!version)return;pin=pin.substr(0,3)+"-"+pin.substr(3,2)+"-"+pin.substr(5,3),this.homebridgePin.textContent=pin,this.buttonsField.classList.remove("hidden")}else this.el.classList.add("hidden")},setHomebridgePin:function(){let homebridge=app.config.get("homebridge"),version=app.config.get("homebridgeversion");if("installing"===homebridge||"install-error"===homebridge||!version)return;let pin=app.config.get("homebridgepin");pin&&(pin=pin.substr(0,3)+"-"+pin.substr(3,2)+"-"+pin.substr(5,3),this.homebridgePin.textContent=pin)},activateAutoUpdate:function(){app.config.save({homebridgeupdate:!0},{patch:!0})},deactivateAutoUpdate:function(){app.config.save({homebridgeupdate:!1},{patch:!0})},setHomebridgeUpdateState:function(){!0===app.config.get("homebridgeupdate")?(this.autoUpdateBtnOn.classList.add("btn-primary"),this.autoUpdateBtnOff.classList.remove("btn-primary")):(this.autoUpdateBtnOff.classList.add("btn-primary"),this.autoUpdateBtnOn.classList.remove("btn-primary"))},setHomebridgeVersion:function(){let version=app.config.get("homebridgeversion");version&&(this.homebridgeVersion.textContent=version)},setHomebridgeUpdateVersion:function(){let updateversion=app.config.get("homebridgeupdateversion"),version=app.config.get("homebridgeversion");version&&updateversion&&(version!==updateversion&&(this.homebridgeUpdateVersion.textContent="("+version+")"),version!==updateversion&&updateversion||(this.homebridgeUpdateVersion.textContent=""))},render:function(){return this}});export const ConnectAppHandlerView=Backbone.View.extend({template:_.template(document.getElementById("connect-app-area-view-template").innerHTML),el:"#connectAppArea",initialize:function(){this.el.innerHTML=this.template(app.config),this.authAllowedElem=this.el.querySelector("#authAllowed"),this.authAppBtn=this.el.querySelector("#connectAppArea button"),this.countdownTime=this.el.querySelector("#countdownTime")},events:{"click button":function(){serviceSend(states.ADVANCED_CONNECT)}},render:function(){return this},showAuthAllowed:function(){this.authAllowedElem.classList.add("show"),this.authAppBtn.classList.add("disabled"),this.countdownTime.textContent=""},hideAuthAllowed:function(){this.authAllowedElem.classList.remove("show"),this.authAppBtn.classList.remove("disabled"),this.countdownTime.textContent=""},countdown:function(seconds){this.countdownTime.textContent=seconds}});export const ChangeChannelHandlerView=Backbone.View.extend({template:_.template(document.getElementById("change-channel-area-view-template").innerHTML),el:"#changeChannelArea",initialize:function(){this.el.innerHTML=this.template(app.config),this.networkId=this.el.querySelector("#networkId"),this.zigbeeChannel=this.el.querySelector("#zigbeeChannel"),this.listenTo(app.config,"change:panid",this.setNetworkId),this.listenTo(app.config,"change:zigbeechannel",this.setZigbeechannel),this.setNetworkId()},events:{"click button":function(){serviceSend(states.ADVANCED_CHANNEL)}},render:function(){return this},setNetworkId:function(){let nId=getNetworkId();nId&&(this.networkId.textContent=nId)},setZigbeechannel:function(){let channel=app.config.get("zigbeechannel");channel&&(this.zigbeeChannel.textContent=channel)}});export const LightDurationHandlerView=Backbone.View.extend({template:_.template(document.getElementById("light-duration-area-view-template").innerHTML),el:"#lightDurationArea",initialize:function(){this.el.innerHTML=this.template(app.config),this.listenTo(app.config,"change:networkopenduration",this.render),this.render()},events:{"click .btn":"sendDur"},render:function(){let elemList=this.el.querySelectorAll("[data-dur]");0!==elemList.length&&removeClassFromAll(elemList,"btn-primary");let lightduration=app.config.get("networkopenduration");if(lightduration){let el=this.el.querySelector('[data-dur="'+lightduration+'"]');el&&el.classList.add("btn-primary")}return this},sendDur:function(ev){ev&&(ev=ev.currentTarget)&&(ev=ev.getAttribute("data-dur"),serviceSend({type:events.LIGHTDUR_PRESSED,activeDur:ev}))}});