/*! phoscon-app 2020-11-15 */

import{states}from"./settings-gateway-constants.js";import{RenameHandlerView}from"./rename-view.js";import{ChangeTimezoneHandlerView}from"./change-timezone-view.js";import{ResetHandlerView}from"./reset-view.js";import{ResetHomebridgeHandlerView}from"./reset-homebridge-view.js";import{SettingsGatewayHandlerView}from"./settings-gateway-view.js";import{SettingsGatewayStatusHandlerView}from"./settings-gateway-status-view.js";import{GeneralHandlerView}from"./top-views.js";import{PowerHandlerView}from"./top-views.js";import{AdvancedHandlerView}from"./top-views.js";import{DiagnoseHandlerView}from"./top-views.js";import{ChangeChannelModalHandlerView}from"./change-channel-modal-view.js";import{ChangePasswordHandlerView}from"./change-login-pw-view.js";import{RestartGwHandlerView}from"./restart-gw-view.js";import{ShutdownGwHandlerView}from"./shutdown-gw-view.js";import{BackupHandlerView}from"./general-states-backup-view.js";import{UpdateHandlerView}from"./general-states-update-view.js";import*as adSub from"./advanced-sub-views.js";import*as adSubStates from"./advanced-sub-states.js";import*as top from"./top-states.js";import*as rename from"./rename-states.js";import*as timezone from"./change-timezone-states.js";import*as reset from"./reset-states.js";import*as changePw from"./change-login-pw-states.js";import*as resetHomebridge from"./reset-homebridge-states.js";import*as restartGateway from"./restart-gw-states.js";import*as shutdownGateway from"./shutdown-gw-states.js";import*as backupGateway from"./general-states-backup-states.js";import*as update from"./general-states-update-states.js";const stateHandlerMap={};var settingsGatewayStatusHandlerView;function initStateHandlers(){new SettingsGatewayHandlerView;settingsGatewayStatusHandlerView=new SettingsGatewayStatusHandlerView;const generalHandlerView=new GeneralHandlerView,powerHandlerView=new PowerHandlerView,advancedHandlerView=new AdvancedHandlerView,diagnoseHandlerView=new DiagnoseHandlerView,connectAppHandlerView=(new adSub.DateHandlerView,new adSub.HomebridgeHandlerView,new adSub.ConnectAppHandlerView),lightDurationHandlerView=(new adSub.ChangeChannelHandlerView,new adSub.LightDurationHandlerView),changePasswordHandlerView=new ChangePasswordHandlerView,renameHanderView=new RenameHandlerView,changeTimezoneHanderView=new ChangeTimezoneHandlerView,resetHandlerView=new ResetHandlerView,backupHandlerView=new BackupHandlerView,updateHandlerView=new UpdateHandlerView,changeChannelModalHandlerView=new ChangeChannelModalHandlerView,resetHomebridgeHandlerView=new ResetHomebridgeHandlerView,restartGwHandlerView=new RestartGwHandlerView,shutdownGwHandlerView=new ShutdownGwHandlerView;stateHandlerMap[states.RESET]=reset.ResetViewHandlerFactory(resetHandlerView),stateHandlerMap[states.RESET_PAGE_1]=reset.ResetViewPage1HandlerFactory(resetHandlerView),stateHandlerMap[states.RESET_PAGE_2]=reset.ResetViewPage2HandlerFactory(resetHandlerView),stateHandlerMap[states.RESET_PAGE_3]=reset.ResetViewPage3HandlerFactory(resetHandlerView),stateHandlerMap[states.RESET_PAGE_4]=reset.ResetViewPage4HandlerFactory(resetHandlerView),stateHandlerMap[states.RESET_HOMEBRIDGE]=resetHomebridge.ResetHomebridgeViewHandlerFactory(resetHomebridgeHandlerView),stateHandlerMap[states.RESET_HOMEBRIDGE_PAGE_1]=resetHomebridge.ResetHomebridgeViewPage1HandlerFactory(resetHomebridgeHandlerView),stateHandlerMap[states.RESET_HOMEBRIDGE_PAGE_2]=resetHomebridge.ResetHomebridgeViewPage2HandlerFactory(resetHomebridgeHandlerView),stateHandlerMap[states.RESET_HOMEBRIDGE_PAGE_3]=resetHomebridge.ResetHomebridgeViewPage3HandlerFactory(resetHomebridgeHandlerView),stateHandlerMap[states.RESET_HOMEBRIDGE_PAGE_4]=resetHomebridge.ResetHomebridgeViewPage4HandlerFactory(resetHomebridgeHandlerView),stateHandlerMap[states.RENAME]=rename.renameViewHandlerFactory(renameHanderView),stateHandlerMap[states.RENAME_PAGE_1_VALID]=rename.renameViewPage1ValidHandlerFactory(renameHanderView),stateHandlerMap[states.RENAME_PAGE_1_INVALID]=rename.renameViewPage1InvalidHandlerFactory(renameHanderView),stateHandlerMap[states.CHANGE_TIMEZONE]=timezone.timezoneViewHandlerFactory(changeTimezoneHanderView),stateHandlerMap[states.CHANGE_TIMEZONE_PAGE_1_VALID]=timezone.timezoneViewPage1ValidHandlerFactory(changeTimezoneHanderView),stateHandlerMap[states.CHANGE_TIMEZONE_PAGE_1_INVALID]=timezone.timezoneViewPage1InvalidHandlerFactory(changeTimezoneHanderView),stateHandlerMap[states.GENERAL]=top.generalViewHandlerFactory(generalHandlerView),stateHandlerMap[states.GENERAL_CHANGE_PASSWORD]=changePw.changePasswordViewHandlerFactory(changePasswordHandlerView),stateHandlerMap[states.GENERAL_CHANGE_PASSWORD_PAGE_1_VALID]=changePw.changePasswordViewPage1ValidHandlerFactory(changePasswordHandlerView),stateHandlerMap[states.GENERAL_CHANGE_PASSWORD_PAGE_1_INVALID]=changePw.changePasswordViewPage1InvalidHandlerFactory(changePasswordHandlerView),stateHandlerMap[states.GENERAL_CHANGE_PASSWORD_PAGE_2]=changePw.changePasswordViewPage2HandlerFactory(changePasswordHandlerView),stateHandlerMap[states.GENERAL_CHANGE_PASSWORD_PAGE_2_VALID]=changePw.changePasswordViewPage2ValidHandlerFactory(changePasswordHandlerView),stateHandlerMap[states.GENERAL_CHANGE_PASSWORD_PAGE_2_INVALID]=changePw.changePasswordViewPage2InvalidHandlerFactory(changePasswordHandlerView),stateHandlerMap[states.GENERAL_CHANGE_PASSWORD_PAGE_SUCCESS]=changePw.changePasswordViewPageSuccessHandlerFactory(changePasswordHandlerView),stateHandlerMap[states.GENERAL_CHANGE_PASSWORD_PAGE_ERROR]=changePw.changePasswordViewPageErrorHandlerFactory(changePasswordHandlerView),stateHandlerMap[states.GENERAL_BACKUP_GW]=backupGateway.generalBackupViewHandlerFactory(backupHandlerView),stateHandlerMap[states.CREATE_BACKUP_PAGE_1]=backupGateway.generalBackupView1HandlerFactory(backupHandlerView),stateHandlerMap[states.CREATE_BACKUP_PAGE_2]=backupGateway.generalBackupView2HandlerFactory(backupHandlerView),stateHandlerMap[states.CREATE_BACKUP_PAGE_2_AFTER_DOWNLOAD]=backupGateway.generalBackupView2AfterDownloadHandlerFactory(backupHandlerView),stateHandlerMap[states.CREATE_BACKUP_PAGE_3]=backupGateway.generalBackupView3HandlerFactory(backupHandlerView),stateHandlerMap[states.LOAD_BACKUP_PAGE_1]=backupGateway.generalBackupViewLoad1HandlerFactory(backupHandlerView),stateHandlerMap[states.LOAD_BACKUP_PAGE_2_INVALID]=backupGateway.generalBackupViewLoad2HandlerFactory(backupHandlerView),stateHandlerMap[states.LOAD_BACKUP_PAGE_2_VALID]=backupGateway.generalBackupViewLoad2HandlerFactory(backupHandlerView),stateHandlerMap[states.LOAD_BACKUP_PAGE_3]=backupGateway.generalBackupViewLoad3HandlerFactory(backupHandlerView),stateHandlerMap[states.LOAD_BACKUP_PAGE_4]=backupGateway.generalBackupViewLoadOkHandlerFactory(backupHandlerView),stateHandlerMap[states.LOAD_BACKUP_PAGE_5]=backupGateway.generalBackupViewLoadFailHandlerFactory(backupHandlerView),stateHandlerMap[states.UPDATE_SW]=update.generalUpdateViewHandlerFactory(updateHandlerView),stateHandlerMap[states.UPDATE_SW_PAGE_1]=update.generalUpdateViewPage1HandlerFactory(updateHandlerView),stateHandlerMap[states.UPDATE_SW_PAGE_BACKUP_1]=update.generalUpdateViewPageBackup1HandlerFactory(updateHandlerView),stateHandlerMap[states.UPDATE_SW_PAGE_BACKUP_2]=update.generalUpdateViewPageBackup2HandlerFactory(updateHandlerView),stateHandlerMap[states.UPDATE_SW_PAGE_BACKUP_2_AFTER_DOWNLOAD]=update.generalUpdateViewPageBackup2AfterDownloadHandlerFactory(updateHandlerView),stateHandlerMap[states.UPDATE_SW_PAGE_BACKUP_3]=update.generalUpdateViewPageBackup3HandlerFactory(updateHandlerView),stateHandlerMap[states.UPDATE_SW_PAGE_2]=update.generalUpdateViewPage2HandlerFactory(updateHandlerView),stateHandlerMap[states.UPDATE_SW_PAGE_3]=update.generalUpdateViewPage3HandlerFactory(updateHandlerView),stateHandlerMap[states.UPDATE_SW_PAGE_4]=update.generalUpdateViewPage4HandlerFactory(updateHandlerView),stateHandlerMap[states.UPDATE_FW]=update.generalUpdateViewHandlerFactory(updateHandlerView),stateHandlerMap[states.UPDATE_FW_PAGE_1]=update.generalUpdateViewPage1FwHandlerFactory(updateHandlerView),stateHandlerMap[states.UPDATE_FW_PAGE_BACKUP_1]=update.generalUpdateViewPageBackup1FwHandlerFactory(updateHandlerView),stateHandlerMap[states.UPDATE_FW_PAGE_BACKUP_2]=update.generalUpdateViewPageBackup2FwHandlerFactory(updateHandlerView),stateHandlerMap[states.UPDATE_FW_PAGE_BACKUP_2_AFTER_DOWNLOAD]=update.generalUpdateViewPageBackup2AfterDownloadFwHandlerFactory(updateHandlerView),stateHandlerMap[states.UPDATE_FW_PAGE_BACKUP_3]=update.generalUpdateViewPageBackup3FwHandlerFactory(updateHandlerView),stateHandlerMap[states.POWER]=top.powerViewHandlerFactory(powerHandlerView),stateHandlerMap[states.RESTART_GW]=restartGateway.restartGwViewHandlerFactory(restartGwHandlerView),stateHandlerMap[states.RESTART_GW_PAGE_1]=restartGateway.restartGwViewPage1HandlerFactory(restartGwHandlerView),stateHandlerMap[states.RESTART_GW_PAGE_2]=restartGateway.restartGwViewPage2HandlerFactory(restartGwHandlerView),stateHandlerMap[states.RESTART_GW_PAGE_3]=restartGateway.restartGwViewPage3HandlerFactory(restartGwHandlerView),stateHandlerMap[states.RESTART_GW_PAGE_4]=restartGateway.restartGwViewPage4HandlerFactory(restartGwHandlerView),stateHandlerMap[states.SHUTDOWN_GW]=shutdownGateway.shutdownGwViewHandlerFactory(shutdownGwHandlerView),stateHandlerMap[states.SHUTDOWN_GW_PAGE_1]=shutdownGateway.shutdownGwViewPage1HandlerFactory(shutdownGwHandlerView),stateHandlerMap[states.SHUTDOWN_GW_PAGE_2]=shutdownGateway.shutdownGwViewPage2HandlerFactory(shutdownGwHandlerView),stateHandlerMap[states.SHUTDOWN_GW_PAGE_3]=shutdownGateway.shutdownGwViewPage3HandlerFactory(shutdownGwHandlerView),stateHandlerMap[states.ADVANCED]=top.advancedViewHandlerFactory(advancedHandlerView),stateHandlerMap[states.ADVANCED_LIGHT_DUR]=adSubStates.lightDurViewHandlerFactory(lightDurationHandlerView),stateHandlerMap[states.ADVANCED_CHANNEL]=adSubStates.channelViewHandlerFactory(changeChannelModalHandlerView),stateHandlerMap[states.ADVANCED_CHANNEL_PAGE_1]=adSubStates.channelViewPage1HandlerFactory(changeChannelModalHandlerView),stateHandlerMap[states.ADVANCED_CHANNEL_PAGE_2]=adSubStates.channelViewPage2HandlerFactory(changeChannelModalHandlerView),stateHandlerMap[states.ADVANCED_CHANNEL_PAGE_3]=adSubStates.channelViewPage3HandlerFactory(changeChannelModalHandlerView),stateHandlerMap[states.ADVANCED_CONNECT]=adSubStates.authAppViewHandlerFactory(connectAppHandlerView),stateHandlerMap[states.DIAGNOSE]=top.diagnoseViewHandlerFactory(diagnoseHandlerView)}export{stateHandlerMap,initStateHandlers,settingsGatewayStatusHandlerView};